library(datasets)
data(iris)
library(cluster)


#plot data
plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=c("red","blue","green")[iris$Species],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)

data_iris=iris[,1:4]
#d=dist(data_iris,"cosine")
d=as.dist(1-cor(t(data_iris), method="pearson"))

library(RColorBrewer)
col_clusters <- brewer.pal(3, "Dark2")

par(mfrow=c(2,3))
dend= as.dendrogram(hclust(d, method = "complete"))
dend1 <- color_branches(dend, k=3,col=col_clusters) 
labels_colors(dend1) = c("red","blue","green")[iris$Species]
plot(dend1,ylab="Distance",cex.lab=1.5,cex=1.5)
dend= as.dendrogram(hclust(d, method = "average"))
dend2 <- color_branches(dend, k=3,col=col_clusters) 
labels_colors(dend2) = c("red","blue","green")[iris$Species]
plot(dend2,ylab="Distance",cex.lab=1.5,cex=1.5)
dend= as.dendrogram(hclust(d, method = "single"))
dend3 <- color_branches(dend, k=3,col=col_clusters) 
labels_colors(dend3) = c("red","blue","green")[iris$Species]
plot(dend3,ylab="Distance",cex.lab=1.5,cex=1.5)

plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=col_clusters[cutree(dend1,3)],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)
plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=col_clusters[cutree(dend2,3)],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)
plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=col_clusters[cutree(dend3,3)],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)


par(mfrow=c(2,3))
res_kmeans=kmeans(data_iris,3)
plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=col_clusters[res_kmeans$cluster],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)

#plot data
plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=c("red","blue","green")[iris$Species],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)


par(mfrow=c(2,3))
#plot(silhouette(res_kmeans$cluster,d), main= "Title k-means k=3")
plot(silhouette(cutree(dend1,2),d), main="Complete Linkage k=2")
plot(silhouette(cutree(dend1,3),d), main="Complete Linkage k=3")
plot(silhouette(cutree(dend1,4),d), main="Complete Linkage k=3")
plot(silhouette(cutree(dend2,2),d), main="Average Linkage k=2")
plot(silhouette(cutree(dend2,3),d), main="Average Linkage k=3")
plot(silhouette(cutree(dend2,4),d), main="Average Linkage k=4")

# gap statistic
# define a generic function using matrix d 
# gap needs resampling of data

hclusCut <- function(x, k, method = "complete", ...) 
  list(cluster = cutree(hclust(as.dist(1-cor(t(x), method="pearson")), method, ...), k=k))


#results on average

res=clusGap(data_iris, FUN = hclusCut, K.max = 8, B = 60, method="average")
par(mfrow=c(2,3))
plot(res$Tab[,1],xlab="k",ylab="W")
lines(1:length(res$Tab[,1]),res$Tab[,1])
plot(res$Tab[,2],xlab="k",ylab="E(W*)")
lines(1:length(res$Tab[,2]),res$Tab[,2])
plot(res,main="")

plot(clusGap(data_iris, FUN = hclusCut, K.max = 8, B = 60, method="complete"),main="")
plot(res,main="")
plot(clusGap(data_iris, FUN = hclusCut, K.max = 8, B = 60, method="single"),main="")


#pca plot 
res_pca=princomp(data_iris)

par(mfrow=c(2,2))
plot(iris$Sepal.Length,iris$Sepal.Width,pch=19,col=c("red","blue","green")[iris$Species],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)
plot(iris$Petal.Length,iris$Petal.Width,pch=19,col=c("red","blue","green")[iris$Species],ylab = "Sepal Width",xlab = "Sepal Heigth", cex.lab=1.5,cex=1.5)
plot(res_pca$scores[,1:2],pch=19,col=c("red","blue","green")[iris$Species],ylab = "PC2",xlab = "PC1", cex.lab=1.5,cex=1.5)
plot(res_pca)

par(mfrow=c(2,2))
#tsne plot
res_tsne=tsne(data_iris)
plot(res_tsne,pch=19,col=c("red","blue","green")[iris$Species],ylab = "t-SNE 1",xlab = "t-SNE 2", cex.lab=1.5,cex=1.5)

res_umap=umap(data_iris)
plot(res_umap$layout,pch=19,col=c("red","blue","green")[iris$Species],ylab = "UMAP 1",xlab = "UMAP 2", cex.lab=1.5,cex=1.5)



